From a6acdc7bb5b75444250f86c1036f3de8d99d3d69 Mon Sep 17 00:00:00 2001
From: a0224068 <yong-zhang@ti.com>
Date: Tue, 16 May 2023 17:37:50 +0800
Subject: [PATCH] am62a bootmode7 emmc

---
 arch/arm/mach-k3/am62a7_init.c | 6 +++++-
 common/spl/spl_mmc.c           | 2 ++
 2 files changed, 7 insertions(+), 1 deletion(-)

diff --git arch/arm/mach-k3/am62a7_init.c arch/arm/mach-k3/am62a7_init.c
index 926585725a..72b3e98ca8 100644
--- arch/arm/mach-k3/am62a7_init.c
+++ arch/arm/mach-k3/am62a7_init.c
@@ -4,7 +4,6 @@
  *
  * Copyright (C) 2022 Texas Instruments Incorporated - https://www.ti.com/
  */
-
 #include <common.h>
 #include <spl.h>
 #include <asm/io.h>
@@ -196,6 +195,11 @@ u32 spl_mmc_boot_mode(const u32 boot_device)
 	u32 devstat = readl(CTRLMMR_MAIN_DEVSTAT);
 	u32 bootmode_cfg = (devstat & MAIN_DEVSTAT_PRIMARY_BOOTMODE_CFG_MASK) >>
 			    MAIN_DEVSTAT_PRIMARY_BOOTMODE_CFG_SHIFT;
+	printf("add by yong, spl_mmc_boot_mode, boot_device=%d devstat:0x%x, bootmode_cfg:0x%x\n",boot_device, devstat, bootmode_cfg);
+	u32 bootmode = (devstat & MAIN_DEVSTAT_PRIMARY_BOOTMODE_MASK) >>
+			    MAIN_DEVSTAT_PRIMARY_BOOTMODE_SHIFT;
+	if (bootmode == BOOT_DEVICE_EMMC)
+	    return MMCSD_MODE_EMMCBOOT;
 
 	switch (boot_device) {
 	case BOOT_DEVICE_MMC1:
diff --git common/spl/spl_mmc.c common/spl/spl_mmc.c
index add2785b4e..09b33c8ea4 100644
--- common/spl/spl_mmc.c
+++ common/spl/spl_mmc.c
@@ -302,6 +302,7 @@ static int spl_mmc_do_fs_boot(struct spl_image_info *spl_image, struct mmc *mmc,
 
 u32 __weak spl_mmc_boot_mode(const u32 boot_device)
 {
+	printf("add by yong, spl_mmc_boot_mode, boot_device=%d\n",boot_device);
 #if defined(CONFIG_SPL_FS_FAT) || defined(CONFIG_SPL_FS_EXT4)
 	return MMCSD_MODE_FS;
 #elif defined(CONFIG_SUPPORT_EMMC_BOOT)
@@ -352,6 +353,7 @@ int spl_mmc_load(struct spl_image_info *spl_image,
 	}
 
 	boot_mode = spl_mmc_boot_mode(bootdev->boot_device);
+	printf("add by yong, boot_mode=%d\n",boot_mode);
 	err = -EINVAL;
 	switch (boot_mode) {
 	case MMCSD_MODE_EMMCBOOT:
-- 
2.17.1

